PROGRAM FallTest;

(* Testet die Funktionalitt von FALLTUER.PAS = FALLTUER.TPU *)

Uses Falltuer, Crt;

VAR
  vector, public                 : VectorT;
  klarFile, codeFile             : STRING;
  divisor, einheit, invers       : CodeT;
  count, choice                  : INTEGER;
  vector_ok, public_ok, param_ok : BOOLEAN;

PROCEDURE PressKey;
(* Wartet auf Drcken der RETURN-Taste *)
VAR
  return : STRING;
BEGIN
  WriteLn;
  Write('Bitte die RETURN-Taste drcken, damit es weitergeht: ');
  ReadLn(return);
END;

PROCEDURE TesteAufbauKomponenten;
(* Bei KeyLength > 16 warscheinlich Umschreiben notig wegen Bildschirmlnge *)
VAR
  count : INTEGER;
BEGIN
  (* Aufbau *)
  ClrScr;
  WriteLn;
  Write('* Test des Aufbaus der Komponenten des Vektors *');
  WriteLn;
  WriteLn;
  AufbauKomponenten(vector);
  (* Zeige den resultierenden Vektor *)
  FOR count:= 1 TO KeyLength DO
  BEGIN
    GotoXY(25,count+3);
    Write('---> Vektor(',count:2,'): ',vector[count]);
  END;
  WriteLn;
  PressKey;
  (* Flag setzten *)
  vector_ok:= TRUE;
  param_ok:= FALSE;
  public_ok:= FALSE;
END;

PROCEDURE TesteBestimme;
BEGIN
  (* Bestimmen *)
  ClrScr;
  WriteLn;
  Write('* Test des Bestimmens von Divisor, Einheit und inversem Element *');
  WriteLn;
  WriteLn;
  (* Prfen, ob alle Werte gesetzt sind *)
  IF NOT vector_ok THEN
    WriteLn('Bitte erst die Komponenten aufbauen !!!')
  ELSE
  BEGIN
    Bestimme(vector,divisor,einheit,invers);
    (* Ergebnisse zeigen *)
    Write('Bestimmen fertig :-) ');
    WriteLn;
    WriteLn;
    Write('Einheit: ',einheit,' / Divisor: ',divisor,' / inverses Element: ');
    WriteLn(invers);
    (* Flag setzten *)
    param_ok:= TRUE;
    public_ok:= FALSE;
  END;
  PressKey;
END;

PROCEDURE TesteAufbauOeffentlicherVektor;
VAR
  count : INTEGER;
BEGIN
  (* Aufbau *)
  ClrScr;
  WriteLn;
  Write('* Test des Aufbaus des ffentlichen Vektors *');
  WriteLn;
  WriteLn;
  (* Prfen, ob alle Werte gesetzt sind *)
  IF NOT ( vector_ok AND param_ok ) THEN
    WriteLn('Bitte erst die Komponenten aufbauen und die Parameter bestimmen !!!')
  ELSE
  BEGIN
    AufbauOeffentlicherVektor(vector,divisor,invers,public);
    (* Zeige den ffentlichen Vektor *)
    FOR count:= 1 TO KeyLength DO
    BEGIN
      Write('ffenlicher Vektor(',count:2,'): ',public[count]);
      WriteLn;
    END;
    (* Flags setzten *)
    public_ok:= TRUE;
  END;
  PressKey;
END;

PROCEDURE TesteVerschluesseln;
VAR
  okay : BOOLEAN;
BEGIN
  ClrScr;
  WriteLn;
  Write('* Test des Verschlsselns *');
  WriteLn;
  WriteLn;
  (* Prfen, ob alle Werte gesetzt sind *)
  IF NOT ( public_ok AND param_ok ) THEN
    WriteLn('Bitte erst die Parameter und den ffentlichen Vektor bestimmen !!!')
  ELSE
  BEGIN
    (* Dateinamen holen *)
    Write('Hierzu mu eine Datei mit dem Klartext existieren. Dieser Klartext wird dann');
    WriteLn;
    Write('eingelesen und in eine Codetext-Datei geschrieben.');
    WriteLn;
    WriteLn;
    Write('Name der Klartext-Datei: ');
    ReadLn(klarFile);
    WriteLn;
    Write('Name der Codetext-Datei: ');
    ReadLn(codeFile);
    (* Verschlsseln *)
    WriteLn;
    okay:= Verschluesseln(public,klarFile,codeFile);
    (* Ergebnis der Prozedur angeben *)
    WriteLn;
    IF NOT okay THEN
      Write('Nanu?! Verschlsseln hat nicht geklappt! :-(')
    ELSE
      Write('Alles klar. Verschlsseln ist fertig! :-)');
    WriteLn;
  END;
  PressKey;
END;

PROCEDURE TesteEntschluesseln;
VAR
  okay : BOOLEAN;
BEGIN
  ClrScr;
  WriteLn;
  Write('* Test des Entschlsselns *');
  WriteLn;
  WriteLn;
  (* Prfen, ob alle Werte gesetzt sind *)
  IF NOT ( vector_ok AND param_ok ) THEN
    WriteLn('Bitte erst die Komponenten aufbauen und die Parameter bestimmen !!!')
  ELSE
  BEGIN
    (* Dateinamen holen *)
    Write('Hierzu mu eine Datei mit dem Codetext existieren. Dieser Codetext wird dann');
    WriteLn;
    Write('eingelesen und ein eine Klartext-Datei geschrieben.');
    WriteLn;
    WriteLn;
    Write('Name der Codetext-Datei: ');
    ReadLn(codeFile);
    WriteLn;
    Write('Name der Klartext-Datei: ');
    ReadLn(klarFile);
    (* Verschlsseln *)
    WriteLn;
    okay:= Entschluesseln(vector,divisor,einheit,codeFile,klarFile);
    (* Ergebnis der Prozedur angeben *)
    WriteLn;
    IF NOT okay THEN
      Write('Nanu?! Entschlsseln hat nicht geklappt! :-(')
    ELSE
      Write('Alles klar. Entschlsseln ist fertig! :-)');
    WriteLn;
  END;
  PressKey;
END;

PROCEDURE SpeichereWerte;
(* Speichert die gefundenen Werte ab. *)
VAR
  geheimFile, publicFile, paramFile : FILE OF CodeT;
  count                             : INTEGER;
BEGIN
  ClrScr;
  WriteLn;
  Write('* Speichere die gefundenen Werte *');
  WriteLn;
  WriteLn;
  (* Prfen, ob alle Werte gesetzt sind *)
  IF NOT ( vector_ok AND public_ok AND param_ok ) THEN
    WriteLn('Bitte erst ALLE Werte bestimmen !!!')
  ELSE
  BEGIN
    (* Dateien ffnen *)
    Assign(geheimFile,'geheim.vec');
    Assign(publicFile,'offen.vec');
    Assign(paramFile,'param.par');
    Rewrite(geheimFile);
    Rewrite(publicFile);
    Rewrite(paramFile);
    (* Daten schreiben *)
    FOR count:= 1 TO KeyLength DO
    BEGIN
      Write(geheimFile,vector[count]);
      (* FIO.WriteLn(geheimFile); *)
      Write(publicFile,public[count]);
      (* FIO.WriteLn(publicFile); *)
      (* Ausgeben *)
      Write('Geheimer Vektor(',count:2,'): ',vector[count]:10);
      Write('  /  ffentlicher Vektor(',count:2);
      Write('): ',public[count]:10);
      WriteLn;
    END;
    Write(paramFile,divisor);
    (* FIO.WriteLn(paramFile); *)
    Write(paramFile,einheit);
    (* FIO.WriteLn(paramFile); *)
    Write(paramFile,invers);
    (* Ausgeben *)
    WriteLn;
    WriteLn;
    Write('Einheit: ',einheit);
    Write(' / Divisor: ',divisor);
    Write(' / inverses Element: ',invers);
    WriteLn;
    (* Dateien schlieen *)
    Close(geheimFile);
    Close(publicFile);
    Close(paramFile);
    WriteLn;
  END;
  PressKey;
END;

PROCEDURE LeseWerte;
(* Liest die gespeicherten Werte ein. *)
VAR
  geheimFile, publicFile, paramFile : FILE OF CodeT;
  count                             : INTEGER;
BEGIN
  ClrScr;
  WriteLn;
  Write('* Lese die gespeicherten Werte *');
  WriteLn;
  WriteLn;
  (* Dateien ffnen *)
  Assign(geheimFile,'geheim.vec');
  Assign(publicFile,'offen.vec');
  Assign(paramFile,'param.par');
  Reset(geheimFile);
  Reset(publicFile);
  Reset(paramFile);
  (* Daten lesen *)
  FOR count:= 1 TO KeyLength DO
  BEGIN
    Read(geheimFile,vector[count]);
    Read(publicFile,public[count]);
    (* Ausgeben *)
    Write('Geheimer Vektor(',count:2,'): ');
    Write(vector[count]:10);
    Write('  /  ffentlicher Vektor(',count:2);
    Write('): ',public[count]:10);
    WriteLn;
  END;
  Read(paramFile,divisor);
  Read(paramFile,einheit);
  Read(paramFile,invers);
  (* Ausgeben *)
  WriteLn;
  WriteLn;
  Write('Einheit: ');
  Write(einheit);
  Write(' / Divisor: ');
  Write(divisor);
  Write(' / inverses Element: ');
  Write(invers);
  WriteLn;
  (* Dateien schlieen *)
  Close(geheimFile);
  Close(publicFile);
  Close(paramFile);
  WriteLn;
  (* Flags setzen *)
  vector_ok:= TRUE;
  public_ok:= TRUE;
  param_ok:=  TRUE;
  PressKey;
END;

BEGIN
  (* Flags initialisieren *)
  vector_ok:= FALSE;
  public_ok:= FALSE;
  param_ok:=  FALSE;
  (* Hauptmen *)
  REPEAT
    ClrScr;
    WriteLn;
    Write('*** Test der Falltrfunktion ***');
    WriteLn;
    WriteLn;
    WriteLn;
    Write('          1 .................................. Komponenten aufbauen  ');
    (* Anzeigen, ob Werte gesetzt sind *)
    IF vector_ok THEN
      Write('(ok)')
    ELSE
      Write('(??)');
    WriteLn;
    WriteLn;
    Write('          2 ......... Einheit, Divisor & inverses Element bestimmen  ');
    (* Anzeigen, ob Werte gesetzt sind *)
    IF param_ok THEN
      Write('(ok)')
    ELSE
      Write('(??)');
    WriteLn;
    WriteLn;
    Write('          3 .......................... ffentlichen Vektor aufbauen  ');
    (* Anzeigen, ob Werte gesetzt sind *)
    IF public_ok THEN
      Write('(ok)')
    ELSE
      Write('(??)');
    WriteLn;
    WriteLn;
    Write('          4 .................................... Text verschlsseln');
    WriteLn;
    WriteLn;
    Write('          5 .................................... Text entschlsseln');
    WriteLn;
    WriteLn;
    Write('          6 ................................. Parameter abspeichern');
    WriteLn;
    WriteLn;
    Write('          7 .................................... Parameter einlesen');
    WriteLn;
    WriteLn;
    Write('          0 ...................................... Programm beenden');
    WriteLn;
    WriteLn;
    WriteLn;
    Write('          Bitte Auswahl eingeben (0-7): ');
    ReadLn(choice);
    CASE choice OF
       1 : TesteAufbauKomponenten;
       2 : TesteBestimme;
       3 : TesteAufbauOeffentlicherVektor;
       4 : TesteVerschluesseln;
       5 : TesteEntschluesseln;
       6 : SpeichereWerte;
       7 : LeseWerte;
    END;
  UNTIL (choice = 0);
  ClrScr;
END.
